Subject: RE: bug#10319: 24.0.92; doc string of `file-remote-p'

From: "Drew Adams" <[email-masked]>
Date: Mon, 19 Dec 2011 08:10:47 -0800

> > Do you just want to say that `file-remote-p' never opens
> > a new connection (i.e., a connection that is not already
> > established/open)?
> 
> Yes.
> 
> > If so, let's just say that: It never opens a new remote
> > connection.  It can only reuse a connection that is
> > already open.
> 
> Sounds OK to me.

Let's do that then.  IMO, that will avoid some misunderstanding.

> > Can the handler establish a _new_ connection?  If so, then
> > `file-remote-p' can do so. If not, then can't we just say
> > that `file-remote-p' never establishes (opens) a new
> > connection?
> 
> It is a promise to libraries using `file-remote-p'. It is guaranteed
> that the function call is cheap, and that it could be used here and
> there w/o remarkable overhead.

That is covered by what is said above: it never opens  new connection.

> It is also an implementation hint. Any handler that provides an own
> implementation of `file-remote-p' shall behave like this.
> `tramp-handle-file-remote-p' and `ange-ftp-file-remote-p' do so.

I doubt that trying to hint that in the doc string will help more than hurt user
understanding.  IMO we would either need to spell that out clearly or put it in
comments in the code.

I think the latter is preferable.  The doc string should be aimed mainly at
users of the function, not at implementors of substitute definitions of it.  But
all of that kind of thing can be stated clearly in the source file for those to
whom it is useful.

> As a consequence, the result might differ whether a connection is
> already open, or not. If the connection is not established yet, we get
> (file-remote-p "/ssh::" 'localname) => ""
> If there is an established connection, we see
> (file-remote-p "/ssh::" 'localname) => "/home/albinus"

That might be worth pointing out in the doc string.  It might be useful to users
of the function.  Perhaps you could just add text like this:

  "The return value can differ depending on whether there
   is an existing connection."

Do we want to say more than that?  Is there some rule about this?  E.g., if no
existing connection is the return value _always_ ""?  If no rule, then just
adding that sentence (or similar) should be enough.

Thx - Drew